// Generated by CoffeeScript 2.3.2
(function() {
  var assembly, calculator, copper, copperPads, courtyard, mountingHole, ncPad, pinNumber, silkscreen;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  pinNumber = 0;

  mountingHole = 1;

  ncPad = 1;

  copperPads = function(pattern, element, suffix = '') {
    var column, columnCount, columnCounts, columnDX, columnDXs, columnDY, columnDYs, hasPads, holeDiameter, horizontalPitch, housing, i, j, k, l, len, number, numbers, p, pad, padDiameter, padHeight, padWidth, pins, points, ref, ref1, ref10, ref11, ref12, ref13, ref14, ref15, ref16, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, row, rowCount, rowDX, rowDXs, rowDY, rowDYs, verticalPitch, x, y;
    housing = element.housing;
    pins = element.pins;
    if (housing['numbers' + suffix] != null) {
      housing['numbers' + suffix] = element.parsePinNumbers(housing['numbers' + suffix]);
    }
    numbers = (ref = housing['numbers' + suffix]) != null ? ref : Object.keys(pins);
    if (!((housing['holeDiameter' + suffix] != null) || (housing['padDiameter' + suffix] != null) || ((housing['padWidth' + suffix] != null) && (housing['padHeight' + suffix] != null)))) {
      return false;
    }
    hasPads = false;
    if (housing['holeDiameter' + suffix] != null) {
      holeDiameter = housing['holeDiameter' + suffix];
      padDiameter = (ref1 = housing['padDiameter' + suffix]) != null ? ref1 : calculator.padDiameter(pattern, housing, holeDiameter);
      padWidth = (ref2 = housing['padWidth' + suffix]) != null ? ref2 : padDiameter;
      padHeight = (ref3 = housing['padHeight' + suffix]) != null ? ref3 : padDiameter;
      pad = {
        type: 'through-hole',
        hole: housing['holeDiameter' + suffix],
        width: padWidth,
        height: padHeight,
        shape: (pinNumber === 0) && housing.polarized ? 'rectangle' : 'circle',
        layer: ['topCopper', 'topMask', 'intCopper', 'bottomCopper', 'bottomMask']
      };
      if ((padWidth < holeDiameter) || (padHeight < holeDiameter)) {
        pad.type = 'mounting-hole';
        pad.layer = ['topCopper', 'topMask', 'intCopper', 'bottomCopper', 'bottomMask'];
        pad.width = holeDiameter;
        pad.height = holeDiameter;
        pad.shape = 'circle';
      }
    } else {
      padDiameter = housing['padDiameter' + suffix];
      padWidth = (ref4 = housing['padWidth' + suffix]) != null ? ref4 : padDiameter;
      padHeight = (ref5 = housing['padHeight' + suffix]) != null ? ref5 : padDiameter;
      pad = {
        type: 'smd',
        width: housing['padWidth' + suffix],
        height: housing['padHeight' + suffix],
        shape: padDiameter != null ? 'circle' : 'rectangle',
        layer: ['topCopper', 'topMask', 'topPaste']
      };
    }
    if (housing['padPosition' + suffix] != null) {
      hasPads = true;
      points = pattern.parsePosition(housing['padPosition' + suffix]);
      for (i = j = 0, len = points.length; j < len; i = ++j) {
        p = points[i];
        pad.x = p.x;
        pad.y = p.y;
        number = pad.type === 'mounting-hole' ? 'MH' + mountingHole++ : (ref6 = numbers[pinNumber++]) != null ? ref6 : 'NC' + ncPad++;
        pattern.pad(number, pad);
        if (housing['holeDiameter' + suffix] != null) {
          pad.shape = 'circle';
        }
      }
    } else if ((housing['rowCount' + suffix] != null) && (housing['columnCount' + suffix] != null)) {
      hasPads = true;
      rowCount = housing['rowCount' + suffix];
      if (rowCount === 1) {
        verticalPitch = 0;
      } else {
        verticalPitch = (ref7 = housing['verticalPitch' + suffix]) != null ? ref7 : housing['pitch' + suffix];
      }
      rowDXs = pattern.parseArray(housing['rowDX' + suffix]);
      rowDYs = pattern.parseArray(housing['rowDY' + suffix]);
      columnCounts = pattern.parseArray(housing['columnCount' + suffix]);
      horizontalPitch = (ref8 = housing['horizontalPitch' + suffix]) != null ? ref8 : housing['pitch' + suffix];
      columnDXs = pattern.parseArray(housing['columnDX' + suffix]);
      columnDYs = pattern.parseArray(housing['columnDY' + suffix]);
      y = -verticalPitch * (rowCount - 1) / 2;
      for (row = k = 0, ref9 = rowCount - 1; (0 <= ref9 ? k <= ref9 : k >= ref9); row = 0 <= ref9 ? ++k : --k) {
        columnCount = (ref10 = columnCounts[row]) != null ? ref10 : columnCounts[0];
        rowDX = (ref11 = rowDXs[row]) != null ? ref11 : rowDXs[0];
        rowDY = (ref12 = rowDYs[row]) != null ? ref12 : rowDYs[0];
        x = -horizontalPitch * (columnCount - 1) / 2;
        for (column = l = 0, ref13 = columnCount - 1; (0 <= ref13 ? l <= ref13 : l >= ref13); column = 0 <= ref13 ? ++l : --l) {
          columnDX = (ref14 = columnDXs[column]) != null ? ref14 : columnDXs[0];
          columnDY = (ref15 = columnDYs[column]) != null ? ref15 : columnDYs[0];
          pad.x = x + rowDX + columnDX;
          pad.y = y + rowDY + columnDY;
          number = pad.type === 'mounting-hole' ? 'MH' + mountingHole++ : (ref16 = numbers[pinNumber++]) != null ? ref16 : 'NC' + ncPad++;
          pattern.pad(number, pad);
          if (housing['holeDiameter' + suffix] != null) {
            pad.shape = 'circle';
          }
          x += horizontalPitch;
        }
        y += verticalPitch;
      }
    }
    return hasPads;
  };

  module.exports = function(pattern, element) {
    var basePoint, bodyPosition, housing, i;
    housing = element.housing;
    if (pattern.name == null) {
      pattern.name = element.group + '_' + element.name.toUpperCase();
    }
    if (housing.bodyPosition == null) {
      housing.bodyPosition = '0, 0';
    }
    bodyPosition = pattern.parsePosition(housing.bodyPosition);
    if (housing.basePoint == null) {
      housing.basePoint = '0, 0';
    }
    basePoint = pattern.parsePosition(housing.basePoint);
    pattern.center(-bodyPosition[0].x + basePoint[0].x, -bodyPosition[0].y + basePoint[0].y);
    pinNumber = 0;
    mountingHole = 1;
    ncPad = 1;
    copperPads(pattern, element);
    i = 1;
    while (true) {
      if (!copperPads(pattern, element, i++)) {
        break;
      }
    }
    pattern.center(0, 0);
    copper.mask(pattern);
    silkscreen.body(pattern, housing);
    if (housing.polarized) {
      assembly.polarized(pattern, housing);
    } else {
      assembly.body(pattern, housing);
    }
    return courtyard.boundary(pattern, housing);
  };

}).call(this);
