// Generated by CoffeeScript 2.3.2
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var firstPad, housing, padParams;
    housing = element.housing;
    housing.polarized = true;
    if (housing.leadWidth == null) {
      housing.leadWidth = housing.leadDiameter;
    }
    if (housing.leadHeight == null) {
      housing.leadHeight = housing.leadDiameter;
    }
    if (pattern.name == null) {
      pattern.name = sprintf("%sDIP%s%dW%dP%dL%dH%dQ%d", housing.ceramic != null ? 'C' : '', housing.socket != null ? 'S' : '', ...[housing.leadSpan.nom * 100, housing.leadWidth.nom * 100, housing.pitch * 100, housing.bodyLength.nom * 100, housing.height.nom * 100, housing.leadCount].map((v) => {
        return Math.round(v);
      }));
    }
    // Calculate pad dimensions according to IPC-7351
    padParams = calculator.throughHole(pattern, housing);
    padParams.distance = housing.leadSpan.nom;
    padParams.pitch = housing.pitch;
    padParams.count = housing.leadCount;
    padParams.order = 'round';
    padParams.pad = {
      type: 'through-hole',
      shape: 'circle',
      hole: padParams.hole,
      width: padParams.width,
      height: padParams.height,
      layer: ['topCopper', 'topMask', 'intCopper', 'bottomCopper', 'bottomMask']
    };
    copper.dual(pattern, element, padParams);
    firstPad = pattern.pads[Object.keys(pattern.pads)[0]];
    firstPad.shape = 'rectangle';
    silkscreen.dual(pattern, housing);
    assembly.polarized(pattern, housing);
    return courtyard.dual(pattern, housing, 0.5);
  };

}).call(this);
