// Generated by CoffeeScript 2.3.2
(function() {
  var calculator, copper, courtyard, silkscreen;

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var angle, count, d, housing, i, j, pad, r, ref, ref1, ref2, ref3, ref4, settings, viaPad;
    housing = element.housing;
    settings = pattern.settings;
    if (pattern.name == null) {
      pattern.name = element.name.toUpperCase();
    }
    pad = {
      x: 0,
      y: 0,
      hole: housing.holeDiameter,
      shape: housing.padDiameter != null ? 'circle' : 'rectangle'
    };
    if ((housing.padDiameter != null) || (housing.padWidth != null) || (housing.padHeight != null)) {
      if (housing.padWidth == null) {
        housing.padWidth = housing.padDiameter;
      }
      if (housing.padHeight == null) {
        housing.padHeight = housing.padDiameter;
      }
      pad.type = 'through-hole';
      pad.layer = ['topCopper', 'topMask', 'intCopper', 'bottomCopper', 'bottomMask'];
      pad.width = (ref = housing.padDiameter) != null ? ref : housing.padWidth;
      pad.height = (ref1 = housing.padDiameter) != null ? ref1 : housing.padHeight;
    } else {
      pad.type = 'mounting-hole';
      pad.layer = ['topCopper', 'topMask', 'intCopper', 'bottomCopper', 'bottomMask'];
      pad.width = housing.holeDiameter;
      pad.height = housing.holeDiameter;
      pad.shape = 'circle';
    }
    pattern.pad(1, pad);
    copper.mask(pattern);
    if (housing.viaDiameter != null) {
      d = (ref2 = housing.padDiameter) != null ? ref2 : Math.min(housing.padWidth, housing.padHeight);
      viaPad = {
        type: 'through-hole',
        shape: 'circle',
        hole: housing.viaDiameter,
        width: housing.viaDiameter + settings.minimum.ringWidth,
        height: housing.viaDiameter + settings.minimum.ringWidth,
        layer: ['topCopper', 'bottomCopper']
      };
      count = (ref3 = housing.viaCount) != null ? ref3 : 8;
      r = housing.holeDiameter / 2 + (d - housing.holeDiameter) / 4;
      for (i = j = 0, ref4 = count - 1; (0 <= ref4 ? j <= ref4 : j >= ref4); i = 0 <= ref4 ? ++j : --j) {
        angle = i * 2 * Math.PI / count;
        viaPad.x = r * Math.cos(angle);
        viaPad.y = r * Math.sin(angle);
        pattern.pad(1, viaPad);
      }
    }
    if (housing.keepout == null) {
      housing.keepout = {
        M: 0.5,
        N: 0.25,
        L: 0.12
      }[settings.densityLevel];
    }
    courtyard.preamble(pattern, housing);
    if (pad.shape === 'circle') {
      pattern.circle(0, 0, pad.width / 2 + housing.keepout);
    } else {
      pattern.rectangle(-pad.width / 2 - housing.keepout, -pad.height / 2 - housing.keepout, pad.width / 2 + housing.keepout, pad.height / 2 + housing.keepout);
    }
    // Assembly layer
    return pattern.layer('topAssembly').lineWidth(settings.lineWidth.assembly).attribute('refDes', {
      x: 0,
      y: 0,
      halign: 'center',
      valign: 'center'
    }).attribute('value', {
      text: pattern.name,
      x: 0,
      y: 0,
      halign: 'center',
      valign: 'center',
      visible: false
    });
  };

}).call(this);
