// Generated by CoffeeScript 2.3.2
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var dx, firstPad, hasTab, housing, leadCount, padParams, settings, width1;
    housing = element.housing;
    housing.polarized = true;
    settings = pattern.settings;
    leadCount = housing.leadCount;
    hasTab = (housing.tabWidth != null) && (housing.tabLength != null);
    if (hasTab) {
      ++leadCount;
    }
    if (pattern.name == null) {
      pattern.name = sprintf("%sSON%dP%dX%dX%d-%d%s", housing.pullBack != null ? 'P' : '', ...[housing.pitch * 100, housing.bodyLength.nom * 100, housing.bodyWidth.nom * 100, housing.height.max * 100, leadCount].map((v) => {
        return Math.round(v);
      }), settings.densityLevel);
    }
    // Calculate pad dimensions according to IPC-7351
    padParams = calculator.son(pattern, housing);
    padParams.pitch = housing.pitch;
    padParams.count = housing.leadCount;
    padParams.order = 'round';
    padParams.pad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width,
      height: padParams.height,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    copper.dual(pattern, element, padParams);
    if (padParams.width1 != null) {
      firstPad = pattern.pads[Object.keys(pattern.pads)[0]];
      width1 = padParams.width1;
      dx = (width1 - firstPad.width) / 2;
      firstPad.x += dx;
      firstPad.width = width1;
    }
    silkscreen.dual(pattern, housing);
    assembly.polarized(pattern, housing);
    courtyard.dual(pattern, housing, padParams.courtyard);
    return copper.tab(pattern, element);
  };

}).call(this);
