// Generated by CoffeeScript 2.3.2
(function() {
    // Class for schematics symbol

  var QedaSymbol,
    splice = [].splice,
    hasProp = {}.hasOwnProperty;

  QedaSymbol = class QedaSymbol {
    
    // Constructor

    constructor(element, name1, part) {
      var both, delta, group, groups, j, k, l, len, len1, pinGroup, pins, ref, schematic, side, sides, toBottom, toLeft, toRight, toTop, v;
      this.name = name1;
      this.settings = element.library.symbol;
      this.shapes = [];
      this.attributes = [];
      this.orientations = [0];
      this.currentLineWidth = 0;
      sides = ['left', 'right', 'top', 'bottom'];
      schematic = element.schematic;
      pins = element.pins;
      if (part != null) {
        this.part = {};
        ref = element.pinGroups;
        for (k in ref) {
          v = ref[k];
          if (part.indexOf(k) !== -1) {
            this.part[k] = v;
          }
        }
      }
      for (j = 0, len = sides.length; j < len; j++) {
        side = sides[j];
        this[side] = [];
        if (schematic[side] != null) {
          groups = element.parseMultiple(schematic[side]);
          if (part != null) {
            groups = groups.filter((v) => {
              return part.indexOf(v) !== -1;
            });
          }
          for (l = 0, len1 = groups.length; l < len1; l++) {
            group = groups[l];
            if (element.pinGroups[group] != null) {
              pinGroup = element.pinGroups[group];
              if (this[side].length && (!schematic.simpified)) {
                this[side].push('--'); // Insert gap
              }
              this[side] = this[side].concat(pinGroup);
            }
          }
        }
      }
      // Divide common pins between left and right evenly
      both = this.left.filter((v) => {
        return (v !== '--') && (this.right.indexOf(v) !== -1);
      });
      delta = Math.ceil((this.right.length - this.left.length + both.length) / 2);
      toLeft = both.slice(0, +(delta - 1) + 1 || 9e9);
      toRight = both.slice(delta);
      this.left = this.left.filter((v) => {
        return toRight.indexOf(v) === -1;
      });
      this.right = this.right.filter((v) => {
        return toLeft.indexOf(v) === -1;
      });
      // Divide common pins between top and bottom evenly
      both = this.top.filter((v) => {
        return (v !== '--') && (this.bottom.indexOf(v) !== -1);
      });
      delta = Math.ceil((this.bottom.length - this.top.length + both.length) / 2);
      toTop = both.slice(0, +(delta - 1) + 1 || 9e9);
      toBottom = both.slice(delta);
      this.top = this.top.filter((v) => {
        return toBottom.indexOf(v) === -1;
      });
      this.bottom = this.bottom.filter((v) => {
        return toTop.indexOf(v) === -1;
      });
      if (schematic.simpified) {
        if (schematic.showPinNames == null) {
          schematic.showPinNames = false;
        }
      }
      this.x = 0;
      this.y = 0;
      this.cx = 0;
      this.cy = 0;
    }

    
    // Align number to grid

    alignToGrid(n, method = 'round') {
      return Math[method](n / this.settings.gridSize) * this.settings.gridSize;
    }

    
    // Add arc

    arc(x, y, radius, start, end) {
      this._addShape('arc', {
        x: this.cx + x,
        y: this.cy + y,
        radius: radius,
        start: start,
        end: end
      });
      return this;
    }

    
    // Add arrow

    arrow(x1, y1, x2, y2, width) {
      var a, x11, x12, y11, y12;
      a = Math.atan((y2 - y1) / (x2 - x1));
      x11 = x1 + width * Math.sin(a) / 2;
      y11 = y1 - width * Math.cos(a) / 2;
      x12 = x1 - width * Math.sin(a) / 2;
      y12 = y1 + width * Math.cos(a) / 2;
      return this.poly(x11, y11, x2, y2, x12, y12, 'background');
    }

    
    // Add attribute

    attribute(name, attribute) {
      var ref;
      attribute.name = name;
      if (attribute.fontSize == null) {
        attribute.fontSize = (ref = this.settings.fontSize[name]) != null ? ref : this.settings.fontSize.default;
      }
      this.attributes[name] = this._addShape('attribute', attribute);
      return this;
    }

    
    // Change center point

    center(x, y) {
      this.cx = x;
      this.cy = y;
      return this;
    }

    
    // Add circle

    circle(x, y, radius, fill = 'none') {
      this._addShape('circle', {
        x: this.cx + x,
        y: this.cy + y,
        radius: radius,
        fill: fill
      });
      return this;
    }

    
    // Add dot

    dot(x, y) {
      this._addShape('line', {
        x1: this.cx + x,
        y1: this.cy + y,
        x2: this.cx + x,
        y2: this.cy + y
      });
      return this;
    }

    
    // Add icon

    icon(x, y, iconObj) {
      iconObj.draw(x, y);
      return this;
    }

    
    // Flip vertically

    invertVertical() {
      var j, l, len, len1, prop, props, ref, results, shape;
      props = ['y', 'y1', 'y2', 'height'];
      ref = this.shapes;
      results = [];
      for (j = 0, len = ref.length; j < len; j++) {
        shape = ref[j];
        for (l = 0, len1 = props.length; l < len1; l++) {
          prop = props[l];
          if (shape[prop] != null) {
            shape[prop] *= -1;
          }
        }
        if (shape['points'] != null) {
          results.push(shape['points'] = shape['points'].map(function(v, i) {
            if (i % 2 === 1) {
              return -v;
            } else {
              return v;
            }
          }));
        } else {
          results.push(void 0);
        }
      }
      return results;
    }

    
    // Add line

    line(x1, y1, x2, y2) {
      if ((x1 !== x2) || (y1 !== y2)) {
        this._addShape('line', {
          x1: this.cx + x1,
          y1: this.cy + y1,
          x2: this.cx + x2,
          y2: this.cy + y2
        });
      }
      return this;
    }

    
    // Line to current position

    lineTo(x, y) {
      this.line(this.x, this.y, x, y);
      return this.moveTo(x, y);
    }

    
    // Set current line width

    lineWidth(lineWidth) {
      this.currentLineWidth = lineWidth;
      return this;
    }

    
    // Change current position

    moveTo(x, y) {
      this.x = x;
      this.y = y;
      return this;
    }

    
    // Add pin

    pin(pin) {
      if (pin.fontSize == null) {
        pin.fontSize = this.settings.fontSize.pin;
      }
      if (pin.space == null) {
        pin.space = this.settings.space.pin;
      }
      pin.x = this.cx + pin.x;
      pin.y = this.cy + pin.y;
      this._addShape('pin', pin);
      return this;
    }

    
    // Add polyline/polygon

    poly(...points) {
      var count, fill, i, j, ref, ref1;
      ref = points, [...points] = ref, [fill] = splice.call(points, -1);
      count = points.length / 2;
      for (i = j = 0, ref1 = count - 1; (0 <= ref1 ? j <= ref1 : j >= ref1); i = 0 <= ref1 ? ++j : --j) {
        points[2 * i] = this.cx + points[2 * i];
        points[2 * i + 1] = this.cy + points[2 * i + 1];
      }
      // Close polyline
      if ((points[0] !== points[points.length - 2]) && (points[1] !== points[points.length - 1])) {
        points.push(points[0]);
        points.push(points[1]);
      }
      this._addShape('poly', {
        points: points,
        fill: fill
      });
      return this;
    }

    
    // Add polyline

    polyline(...points) {
      return this.poly(...points, 'none');
    }

    
    // Add rectangle

    rectangle(x1, y1, x2, y2, fill = 'none') {
      this._addShape('rectangle', {
        x1: this.cx + x1,
        y1: this.cy + y1,
        x2: this.cx + x2,
        y2: this.cy + y2,
        fill: fill
      });
      return this;
    }

    
    // Resize symbol to new grid size

    resize(gridSize, needRound = false, shift_x = 0, shift_y = 0) {
      var c, factor, i, j, l, len, len1, len2, m, prop, props, ref, ref1, resize_value, results, shape;
      factor = gridSize / this.settings.gridSize;
      resize_value = (value) => {
        value = value * factor;
        if (needRound) {
          return Math.round(value);
        } else {
          return value;
        }
      };
      ref = ['width', 'height'];
      for (j = 0, len = ref.length; j < len; j++) {
        prop = ref[j];
        this[prop] = resize_value(this[prop]);
      }
      props = ['x', 'x1', 'x2', 'y', 'y1', 'y2', 'width', 'height', 'length', 'lineWidth', 'fontSize', 'space', 'radius'];
      ref1 = this.shapes;
      results = [];
      for (l = 0, len1 = ref1.length; l < len1; l++) {
        shape = ref1[l];
        for (m = 0, len2 = props.length; m < len2; m++) {
          prop = props[m];
          if (shape[prop] != null) {
            if (prop === 'x' || prop === 'x1' || prop === 'x2') {
              shape[prop] += shift_x;
            } else if (prop === 'y' || prop === 'y1' || prop === 'y2') {
              shape[prop] += shift_y;
            }
            shape[prop] = resize_value(shape[prop]);
          }
        }
        if (shape.points != null) {
          results.push((function() {
            var ref2, results1, z;
            ref2 = shape.points.entries();
            results1 = [];
            for (z of ref2) {
              [i, c] = z;
              if (i % 2 === 0) {
                shape.points[i] += shift_x;
              } else {
                shape.points[i] += shift_y;
              }
              results1.push(shape.points[i] = resize_value(shape.points[i]));
            }
            return results1;
          })());
        } else {
          results.push(void 0);
        }
      }
      return results;
    }

    
    // Add text string

    text(text) {
      if (text.fontSize == null) {
        text.fontSize = this.settings.fontSize.default;
      }
      if (text.angle == null) {
        text.angle = 0;
      }
      this._addShape('text', text);
      return this;
    }

    
    // Get text height

    textWidth(text, textType = 'default') {
      return this.settings.fontSize[textType] * text.length;
    }

    
    // Add arbitrary shape object

    _addShape(kind, shape) {
      var obj, prop;
      obj = {
        kind: kind
      };
      for (prop in shape) {
        if (!hasProp.call(shape, prop)) continue;
        obj[prop] = shape[prop];
      }
      if (obj.lineWidth == null) {
        obj.lineWidth = this.currentLineWidth;
      }
      this.shapes.push(obj);
      return obj;
    }

  };

  module.exports = QedaSymbol;

}).call(this);
