// Generated by CoffeeScript 2.3.2
(function() {
  var CapacitorIcon, CrystalIcon, DiodeIcon, FetIcon, FuseIcon, Icon, Icons, InductorIcon, PushbuttonIcon, ResistorIcon, SwitchIcon, TransistorIcon;

  Icon = require('./icon');

  
  // Capacitor

  CapacitorIcon = class CapacitorIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 1.5, height = 8);
      this.d = {
        w: this.width,
        h: this.height,
        gap: this.width / 1.5,
        r: 6 * this.width
      };
    }

    draw(x, y) {
      var a;
      // Left plate
      this.symbol.lineWidth(this.lineWidth).center(x, y).line(-this.d.w / 2, -this.d.h / 2, -this.d.w / 2, this.d.h / 2); // Set center to (x, y)
      if (this.schematic.polarized) {
        // Right plate
        a = 180 * Math.asin(this.d.h / (2 * this.d.r)) / Math.PI;
        this.symbol.arc(this.d.r + this.d.w / 2, 0, this.d.r, 180 - a, 180 + a);
        // Plus sign
        x = -this.d.w / 2 - 2 * this.d.gap;
        y = -this.d.h / 4;
        this.symbol.lineWidth(this.settings.lineWidth.thin).line(x - this.d.gap, y, x + this.d.gap, y).line(x, y - this.d.gap, x, y + this.d.gap).lineWidth(this.lineWidth);
      } else {
        // Right plate
        this.symbol.line(this.d.w / 2, -this.d.h / 2, this.d.w / 2, this.d.h / 2);
      }
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // Crystal

  CrystalIcon = class CrystalIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 6, height = 8);
      this.d = {
        w: this.width,
        h: this.height,
        gap: this.width / 4,
        dy: this.height / 4
      };
    }

    draw(x, y) {
      var settings;
      settings = this.symbol.settings;
      // Body
      // Left plate
      // Right plate
      return this.symbol.lineWidth(this.lineWidth).center(x, y).rectangle(-this.d.w / 2 + this.d.gap, -this.height / 2, this.d.w / 2 - this.d.gap, this.height / 2, settings.fill).line(-this.d.w / 2, -this.d.h / 2 + this.d.dy, -this.d.w / 2, this.d.h / 2 - this.d.dy).line(this.d.w / 2, -this.d.h / 2 + this.d.dy, this.d.w / 2, this.d.h / 2 - this.d.dy).center(0, 0); // Set center to (x, y) // Restore default center point
    }

  };

  
  // Diode

  DiodeIcon = class DiodeIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 4, height = 5);
      if (this.schematic.tvs) {
        this.width *= 2;
      }
      this.d = {
        w: this.width,
        h: this.height,
        d: this.width / 4,
        gap: Math.max(this.height, this.width) / 4,
        aw: this.width / 4
      };
      if (this.schematic.tvs || this.schematic.zener) {
        this.height += 2 * this.d.d;
      }
    }

    draw(x, y, rotated = false) {
      var d, f, len, settings, x1, x2, xa, y1, y2, ya;
      settings = this.symbol.settings;
      f = rotated ? -1 : 1;
      x1 = f * (-this.d.w / 2);
      y1 = f * (-this.d.h / 2);
      x2 = f * this.d.w / 2;
      y2 = f * this.d.h / 2;
      this.symbol.lineWidth(this.lineWidth).center(x, y); // Set center to (x, y)
      if (this.schematic.tvs) {
        d = f * this.d.d;
        // Left triangle
        // Right triangle
        // Central line
        this.symbol.poly(x1, y1, 0, 0, x1, y2, x1, y1, settings.fill).poly(x2, y1, 0, 0, x2, y2, x2, y1, settings.fill).line(0, y1, 0, y2).line(0, y1, -d, y1 - d).line(0, y2, d, y2 + d);
      } else {
        // Triangle & line
        this.symbol.poly(x1, y1, x2, 0, x1, y2, x1, y1, settings.fill).line(x2, y1, x2, y2);
        if (this.schematic.schottky) {
          d = f * this.d.d;
          // Bottom twirl
          // Top twirl
          this.symbol.moveTo(x2, y2).lineTo(x2 - d, y2).lineTo(x2 - d, y2 - d).moveTo(x2, y1).lineTo(x2 + d, y1).lineTo(x2 + d, y1 + d);
        } else if (this.schematic.zener) {
          d = f * this.d.d;
          this.symbol.line(x2, y1, x2 - d, y1 - d).line(x2, y2, x2 + d, y2 + d);
        } else if (this.schematic.led) {
          d = f * this.d.gap;
          len = 2 * d;
          xa = Math.max(this.d.w, this.d.h) / 2;
          ya = -xa;
          x1 = xa;
          y1 = ya - d;
          x2 = xa + d;
          y2 = ya;
          // Arrows
          this.symbol.line(x1, y1, x1 + len, y1 - len).arrow(x1 + len / 2, y1 - len / 2, x1 + len, y1 - len, this.d.aw).line(x2, y2, x2 + len, y2 - len).arrow(x2 + len / 2, y2 - len / 2, x2 + len, y2 - len, this.d.aw);
        }
      }
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // FET

  FetIcon = class FetIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      width = 15;
      height = 9;
      width = 2 * symbol.alignToGrid(width / 2, 'ceil');
      height = 2 * symbol.alignToGrid(height / 2, 'ceil');
      super(symbol, element, width, height);
      this.d = {
        w: this.width,
        h: this.height,
        space: this.width / 10,
        gap: this.height / 9,
        aw: this.width / 10
      };
    }

    draw(x, y) {
      var dx, h, i, j, l, w;
      dx = this.schematic.diode && (!this.schematic.jfet) ? -this.d.w / 8 : 0;
      this.symbol.lineWidth(this.lineWidth).center(x, y); // Set center to (x, y)
      if (this.schematic.depletion || this.schematic.jfet) {
        // Central line
        this.symbol.line(dx, -this.d.h / 2, dx, this.d.h / 2); // Enhancement
      } else {
        // Three dashes
        y = -this.d.h / 2;
        l = (this.d.h - 2 * this.d.gap) / 3;
        for (i = j = 1; j <= 3; i = ++j) {
          this.symbol.line(dx, y, dx, y + l);
          y += l + this.d.gap;
        }
      }
      y = (this.d.h + this.d.gap) / 3;
      this.symbol.line(dx, y, this.d.w / 2, y).line(this.d.w / 2, y, this.d.w / 2, this.d.h / 2).line(dx, -y, this.d.w / 2, -y).line(this.d.w / 2, -y, this.d.w / 2, -this.d.h / 2);
      if (this.schematic.jfet) {
        this.symbol.line(-this.d.w / 2, this.d.h / 2, dx, this.d.h / 2);
        if (this.schematic.n) {
          this.symbol.arrow(dx - this.d.w / 8, this.d.h / 2, dx, this.d.h / 2, this.d.aw);
        }
        if (this.schematic.p) {
          this.symbol.arrow(dx - this.d.w / 8, this.d.h / 2, dx - this.d.w / 4, this.d.h / 2, this.d.aw);
        }
      } else {
        this.symbol.line(-this.d.w / 2, this.d.h / 2, dx - this.d.space, this.d.h / 2).line(dx - this.d.space, -this.d.h / 2, dx - this.d.space, this.d.h / 2).line(dx, 0, dx + this.d.w / 4, 0).line(dx + this.d.w / 4, 0, dx + this.width / 4, (this.d.h + this.d.gap) / 3);
        if (this.schematic.n) {
          this.symbol.arrow(dx + this.d.w / 8, 0, dx, 0, this.d.aw);
        }
        if (this.schematic.p) {
          this.symbol.arrow(dx + this.d.w / 8, 0, dx + this.d.w / 4, 0, this.d.aw);
        }
      }
      if (this.schematic.diode) {
        x = this.d.w / 8 + this.d.space;
        w = this.d.w / 8;
        h = w / 2 * Math.tan(Math.PI / 3);
        // Diode "pins"
        this.symbol.line(x + w / 2, -(this.d.h + this.d.gap) / 3, x + w / 2, -h / 2).line(x + w / 2, h / 2, x + w / 2, (this.d.h + this.d.gap) / 3);
        // Triangle and line
        if (this.schematic.n) {
          this.symbol.polyline(x, h / 2, x + w, h / 2, x + w / 2, -h / 2, x, h / 2).line(x, -h / 2, x + w, -h / 2);
        } else if (this.schematic.p) {
          this.symbol.polyline(x, -h / 2, x + w, -h / 2, x + w / 2, h / 2, x, -h / 2).line(x, h / 2, x + w, h / 2);
        }
      }
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // Fuse

  FuseIcon = class FuseIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 10, height = 4);
      this.d = {
        w: this.width,
        h: this.height
      };
    }

    draw(x, y) {
      var settings;
      settings = this.symbol.settings;
      this.symbol.lineWidth(this.lineWidth).center(x, y).rectangle(-this.d.w / 2, -this.d.h / 2, this.d.w / 2, this.d.h / 2, settings.fill).line(-this.d.w / 2, 0, this.d.w / 2, 0); // Set center to (x, y)
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // Inductor

  InductorIcon = class InductorIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      width = 20;
      super(symbol, element, width, height = width / 8);
      this.d = {
        w: this.width,
        h: this.height,
        r: this.width / 8
      };
      this.y1 = -this.height;
      this.y2 = 0;
    }

    draw(x, y) {
      var i, j;
      this.symbol.lineWidth(this.lineWidth).center(x, y); // Set center to (x, y)
      x = -3 * this.d.r;
      for (i = j = 1; j <= 4; i = ++j) {
        this.symbol.arc(x, 0, this.d.r, 180, 0);
        x += 2 * this.d.r;
      }
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // Pushbutton

  PushbuttonIcon = class PushbuttonIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 10, height = 6);
      this.d = {
        w: this.width,
        h: this.height,
        r: this.height / 6
      };
      this.y1 = -this.height;
      this.y2 = this.d.r;
      this.height += this.d.r;
    }

    draw(x, y) {
      return this.symbol.lineWidth(this.lineWidth).center(x, y).circle(-this.d.w / 2 + this.d.r, 0, this.d.r).circle(this.d.w / 2 - this.d.r, 0, this.d.r).line(-this.d.w / 2, -this.d.h / 2, this.d.w / 2, -this.d.h / 2).line(0, -this.d.h / 2, 0, -this.d.h).center(0, 0); // Set center to (x, y) // Restore default center point
    }

  };

  
  // Resistor

  ResistorIcon = class ResistorIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 10, height = 4);
      this.d = {
        w: this.width,
        h: this.height,
        d: this.height / 4
      };
      if (this.schematic.trimpot) {
        this.height = 2 * this.height + this.d.d;
        this.y1 = -this.height / 2 - this.d.d;
        this.y2 = this.height / 2;
      }
    }

    draw(x, y) {
      var settings;
      settings = this.symbol.settings;
      this.symbol.lineWidth(this.lineWidth).center(x, y).rectangle(-this.d.w / 2, -this.d.h / 2, this.d.w / 2, this.d.h / 2, settings.fill); // Set center to (x, y)
      if (this.schematic.trimpot) {
        this.symbol.line(-this.d.h, this.d.h, this.d.h, -this.d.h).line(this.d.h - this.d.d, -this.d.h - this.d.d, this.d.h + this.d.d, -this.d.h + this.d.d);
      }
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // Switch

  SwitchIcon = class SwitchIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 4, height = 8);
      this.d = {
        w: this.width,
        h: this.height
      };
    }

    draw(x, y) {
      var settings;
      settings = this.symbol.settings;
      this.symbol.lineWidth(this.lineWidth).center(x, y).rectangle(-this.d.w / 2, -this.d.h / 2, this.d.w / 2, 0, 'none').rectangle(-this.d.w / 2, 0, this.d.w / 2, this.d.h / 2, 'background'); // Set center to (x, y)
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // Transistor

  TransistorIcon = class TransistorIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      width = 12;
      height = 9;
      width = 2 * symbol.alignToGrid(width / 2, 'ceil');
      height = 2 * symbol.alignToGrid(height / 2, 'ceil');
      super(symbol, element, width, height);
      this.d = {
        w: this.width,
        h: this.height,
        gap: this.width / 8,
        aw: this.width / 8
      };
    }

    draw(x, y) {
      var a, dx, dy, x1, x2, x3, x4, y1, y2, y3, y4;
      this.symbol.lineWidth(this.lineWidth).center(x, y).line(0, -this.d.h / 2, 0, this.d.h / 2).line(0, -this.d.h / 4, this.d.w / 2, -this.d.h / 2).line(0, this.d.h / 4, this.d.w / 2, this.d.h / 2); // Set center to (x, y)
      if (this.schematic.igbt) {
        this.symbol.line(-this.d.w / 2, 0, -this.d.gap, 0).line(-this.d.gap, -this.d.h / 2, -this.d.gap, this.height / 2);
      } else {
        this.symbol.line(-this.d.w / 2, 0, 0, 0);
      }
      dx = this.d.w / 2;
      dy = this.d.h / 4;
      x1 = dx / 2;
      y1 = this.d.h / 4 + dy / 2;
      x2 = x1 - dx / 4;
      y2 = y1 - dy / 4;
      a = Math.atan(dy / dx);
      if (this.schematic.npn || this.schematic.igbt) {
        x3 = x2 + this.d.aw * Math.sin(a) / 2;
        y3 = y2 - this.d.aw * Math.cos(a) / 2;
        x4 = x2 - this.d.aw * Math.sin(a) / 2;
        y4 = y2 + this.d.aw * Math.cos(a) / 2;
        this.symbol.poly(x1, y1, x3, y3, x4, y4, 'background');
      }
      if (this.schematic.pnp) {
        x3 = x1 + this.d.aw * Math.sin(a) / 2;
        y3 = y1 - this.d.aw * Math.cos(a) / 2;
        x4 = x1 - this.d.aw * Math.sin(a) / 2;
        y4 = y1 + this.d.aw * Math.cos(a) / 2;
        this.symbol.poly(x2, y2, x3, y3, x4, y4, 'background');
      }
      return this.symbol.center(0, 0); // Restore default center point
    }

  };

  
  // Export object

  Icons = {};

  Icons.Capacitor = CapacitorIcon;

  Icons.Crystal = CrystalIcon;

  Icons.Diode = DiodeIcon;

  Icons.Fet = FetIcon;

  Icons.Fuse = FuseIcon;

  Icons.Inductor = InductorIcon;

  Icons.Pushbutton = PushbuttonIcon;

  Icons.Resistor = ResistorIcon;

  Icons.Switch = SwitchIcon;

  Icons.Transistor = TransistorIcon;

  module.exports = Icons;

}).call(this);
