// Generated by CoffeeScript 2.3.2
(function() {
  var Icon, PinIcon, enclosure;

  enclosure = require('./common/enclosure');

  Icon = require('./common/icon');

  PinIcon = class PinIcon extends Icon {
    constructor(symbol, element) {
      var height, width;
      super(symbol, element, width = 5, height = 5);
      this.d = {
        r: this.width / 4
      };
    }

    draw(x, y) {
      if (this.schematic['square-pin']) {
        return this.symbol.poly(x - this.d.r, y - this.d.r, x + this.d.r, y - this.d.r, x + this.d.r, y + this.d.r, x - this.d.r, y + this.d.r, x - this.d.r, y - this.d.r, 'background');
      } else {
        return this.symbol.circle(x, y, this.d.r, 'background');
      }
    }

  };

  module.exports = function(symbol, element) {
    var half, i, j, k, l, len, len1, len2, len3, m, n, number, numbers, o, p, pinIcon, pins, q, r, ref, ref1, ref2, ref3, ref4, ref5, schematic, v;
    schematic = element.schematic;
    element.refDes = 'J';
    pinIcon = new PinIcon(symbol, element);
    if (schematic.showPinNames == null) {
      schematic.showPinNames = true;
    }
    if (schematic.showPinNumbers == null) {
      schematic.showPinNumbers = true;
    }
    schematic.pinIcon = pinIcon;
    schematic.symmetrical = true;
    if ((!symbol.left.length) && (!symbol.right.length)) { // Automatic
      numbers = Object.keys(element.pins);
      if (schematic.single) {
        numbers.map(function(v) {
          return symbol.right.push(v);
        });
      } else if (schematic.ccw) {
        half = Math.ceil(numbers.length / 2);
        for (i = j = 0, ref = half - 1; (0 <= ref ? j <= ref : j >= ref); i = 0 <= ref ? ++j : --j) {
          symbol.left.push(numbers[i]);
        }
        for (i = l = ref1 = half, ref2 = numbers.length - 1; (ref1 <= ref2 ? l <= ref2 : l >= ref2); i = ref1 <= ref2 ? ++l : --l) {
          symbol.right.unshift(numbers[i]);
        }
      } else if (schematic.cw) {
        half = Math.ceil(numbers.length / 2);
        for (i = m = 0, ref3 = half - 1; (0 <= ref3 ? m <= ref3 : m >= ref3); i = 0 <= ref3 ? ++m : --m) {
          symbol.right.push(numbers[i]);
        }
        for (i = n = ref4 = half, ref5 = numbers.length - 1; (ref4 <= ref5 ? n <= ref5 : n >= ref5); i = ref4 <= ref5 ? ++n : --n) {
          symbol.left.unshift(numbers[i]);
        }
      } else if (schematic.mirror) {
        for (o = 0, len = numbers.length; o < len; o += 2) {
          number = numbers[o];
          symbol.right.push(number);
        }
        numbers.shift();
        for (p = 0, len1 = numbers.length; p < len1; p += 2) {
          number = numbers[p];
          symbol.left.push(number);
        }
      } else {
        for (q = 0, len2 = numbers.length; q < len2; q += 2) {
          number = numbers[q];
          symbol.left.push(number);
        }
        numbers.shift();
        for (r = 0, len3 = numbers.length; r < len3; r += 2) {
          number = numbers[r];
          symbol.right.push(number);
        }
      }
    }
    pins = element.pins;
    for (k in pins) {
      v = pins[k];
      if (pins[k].nc !== true) {
        pins[k].passive = true;
      }
    }
    return enclosure(symbol, element);
  };

}).call(this);
