// Generated by CoffeeScript 2.3.2
(function() {
  var groundSymbol;

  groundSymbol = function(symbol, element, icon = 'signal') {
    var d, height, schematic, settings, width;
    settings = symbol.settings;
    schematic = element.schematic;
    width = 5 * settings.factor;
    height = 5 * settings.factor;
    symbol.attribute('refDes', {
      x: 0,
      y: -settings.space.attribute,
      halign: 'center',
      valign: 'bottom',
      visible: false
    }).attribute('name', {
      x: 0,
      y: height + settings.space.attribute,
      halign: 'center',
      valign: 'top'
    }).pin({
      number: 1,
      name: element.name,
      x: 0,
      y: 0,
      length: 0,
      orientation: 'down',
      ground: true,
      invisible: true
    }).lineWidth(settings.lineWidth.thick).line(0, 0, 0, (schematic.signal || schematic.earth || schematic.chassis ? height / 2 : height));
    if (schematic.signal) {
      element.description = 'Signal Ground Symbol';
      return symbol.poly(-width / 2, height / 2, width / 2, height / 2, 0, height, -width / 2, height / 2, settings.fill);
    } else if (schematic.earth) {
      element.description = 'Earth Ground Symbol';
      d = width / 5;
      return symbol.line(-width / 2, height / 2, width / 2, height / 2).line(-width / 2 + d, 3 * height / 4, width / 2 - d, 3 * height / 4).line(-width / 2 + 2 * d, height, width / 2 - 2 * d, height);
    } else if (schematic.chassis) {
      element.description = 'Chassis Ground Symbol';
      d = width / 4;
      return symbol.line(-width / 2, height / 2, width / 2, height / 2).line(-width / 2, height / 2, -width / 2 - d, height).line(0, height / 2, -d, height).line(width / 2, height / 2, width / 2 - d, height);
    } else {
      element.description = 'Ground Symbol';
      return symbol.line(-width / 2, height, width / 2, height);
    }
  };

  module.exports = function(symbol, element) {
    var schematic;
    element.refDes = '#PWR';
    element.power = true;
    schematic = element.schematic;
    if (schematic.showPinNames == null) {
      schematic.showPinNames = false;
    }
    if (schematic.showPinNumbers == null) {
      schematic.showPinNumbers = false;
    }
    return groundSymbol(symbol, element);
  };

}).call(this);
