// Generated by CoffeeScript 2.3.2
(function() {
  var designators, pinTextWidth, purposes, updateElement;

  designators = {
    DA: ['analog'],
    DC: ['capacitor'],
    DD: ['digital'],
    DR: ['resistor']
  };

  purposes = {
    '1': ['invertor', 'repeater', 'or'],
    '&': ['and'],
    '>': ['opamp'],
    'ADC': ['adc'],
    'BUF': ['buffer'],
    'BUS': ['bus'],
    '*C': ['capacitor'],
    'CD': ['coder'],
    'COMP': ['comparator', 'supervisor', 'reset'],
    'CPU': ['cpu'],
    'CTR': ['counter'],
    '*D': ['diode'],
    'DAC': ['dac'],
    'DC': ['decoder'],
    'DEV': ['device'],
    'DIV': ['divider'],
    'DM': ['demodulator'],
    'DPY': ['display'],
    'DRAM': ['ram', 'dram', 'dynamic'],
    'DRV': ['driver'],
    'DX': ['demultiplexor'],
    'FIFO': ['fifo'],
    'G': ['generator'],
    '*L': ['inductor'],
    'M': ['memory'],
    'M2': ['xor'],
    'MD': ['modulator'],
    'MOD': ['modificator'],
    'MPU': ['mcu', 'microcontroller', 'microprocessor', 'mpu'],
    'MUX': ['multiplexer'],
    'NVRAM': ['ram', 'nvram', 'mram', 'fram', 'non-volatile'],
    'PLM': ['cpld', 'fpga'],
    'PPI': ['interface', 'programmable'],
    'PROM': ['rom', 'prom', 'programmable'],
    '*R': ['resistor'],
    'RAM': ['ram'],
    'RG': ['register'],
    'ROM': ['rom'],
    'RPROM': ['rom', 'rpprom', 'reprogrammable'],
    'RTX': ['isolator', 'interface', 'transceiver'],
    'SM': ['adder'],
    'SRAM': ['ram', 'sram', 'static'],
    '*ST': ['regulator', 'stabilizer'],
    '*STU': ['ac-dc', 'dc-dc', 'ldo', 'regulator', 'reference', 'step-down', 'voltage'],
    'SUB': ['subtractor'],
    'SW': ['optocoupler', 'relay', 'switch'],
    '*T': ['transistor'],
    'TH': ['hysteresis', 'threshold'],
    'X/Y': ['converter', 'sensor']
  };

  updateElement = function(element) {
    var classes, designator, keywords, purpose, purposeWeight, refWeight, results, weight;
    if (element.keywords == null) {
      return;
    }
    keywords = element.keywords.toLowerCase().replace(/\s+/g, '').split(',');
    refWeight = 0;
    for (designator in designators) {
      classes = designators[designator];
      weight = keywords.filter((a) => {
        return classes.indexOf(a) !== -1;
      }).length;
      if (weight > refWeight) {
        refWeight = weight;
        element.refDes = designator;
      }
    }
    purposeWeight = 0;
    results = [];
    for (purpose in purposes) {
      classes = purposes[purpose];
      weight = keywords.filter((a) => {
        return classes.indexOf(a) !== -1;
      }).length;
      if (weight > purposeWeight) {
        purposeWeight = weight;
        results.push(element.purpose = purpose);
      } else {
        results.push(void 0);
      }
    }
    return results;
  };

  pinTextWidth = function(symbol, pin, space, visible) {
    if (visible) {
      return symbol.textWidth(pin.name, 'pin') + space;
    } else {
      return 0;
    }
  };

  module.exports = function(symbol, element) {
    var height, i, j, k, l, left, leftFirst, leftLast, leftPins, leftYs, len, len1, len2, len3, len4, len5, m, n, noLeftText, noRightText, o, p, pin, pinLength, pinSpace, pins, pitch, q, ref, ref1, ref2, ref3, ref4, results, right, rightFirst, rightLast, rightPins, rightYs, schematic, settings, space, textWidth, w, width, x, x1, x2, y;
    element.refDes = 'D';
    element.purpose = '';
    updateElement(element);
    schematic = element.schematic;
    settings = symbol.settings;
    if (schematic.showPinNames == null) {
      schematic.showPinNames = true;
    }
    if (schematic.showPinNumbers == null) {
      schematic.showPinNumbers = true;
    }
    pitch = symbol.alignToGrid((ref = settings.pitch) != null ? ref : 5);
    pinLength = symbol.alignToGrid((ref1 = settings.pinLength) != null ? ref1 : 10);
    pinSpace = (ref2 = schematic.pinSpace) != null ? ref2 : settings.space.pin;
    space = settings.space.default;
    left = symbol.left;
    if (symbol.top.length) { // Move top pins to the left side
      if (left.length) {
        left.push('--');
      }
      left = left.concat(symbol.top);
    }
    right = symbol.right;
    if (symbol.bottom.length) { // Move bottom pins to the right side
      if (right.length) {
        right.push('--');
      }
      right = right.concat(symbol.bottom);
    }
    pins = element.pins;
    // Attributes
    symbol.attribute('refDes', {
      x: 0,
      y: -settings.space.attribute,
      halign: 'center',
      valign: 'bottom'
    }).attribute('Function', {
      x: 0,
      y: 2 * settings.space.attribute,
      halign: 'center',
      valign: 'top',
      text: element.purpose
    });
    textWidth = symbol.textWidth(element.purpose, 'name');
    width = textWidth;
    height = pitch * (Math.max(left.length, right.length) + 1);
    if (element.parts != null) {
      symbol.attribute('name', {
        x: 0,
        y: settings.fontSize.name + 4 * settings.space.attribute,
        halign: 'right',
        valign: 'center',
        orientation: 'vertical'
      });
    } else {
      symbol.attribute('name', {
        x: 0,
        y: height + settings.space.attribute,
        halign: 'center',
        valign: 'top'
      });
    }
    // Pins on the left side
    x = -width / 2;
    leftPins = [];
    leftYs = [];
    y = height / 2 - pitch * left.length / 2 + pitch / 2;
    noLeftText = true;
    for (j = 0, len = left.length; j < len; j++) {
      i = left[j];
      if (i === '--') {
        if (typeof leftFirst === "undefined" || leftFirst === null) {
          leftFirst = leftPins.length - 1;
        }
        leftLast = leftPins.length;
        leftYs.push(y);
        y += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'right';
      leftPins.push(pin);
      if (pin.name.length) {
        noLeftText = false;
      }
      w = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      x1 = -width / 2 - w - space;
      if (x > x1) {
        x = x1; // Make symbol wider
      }
      y += pitch;
    }
    width = Math.max(width, -2 * x);
    // Pins on the right side
    x = width / 2;
    rightPins = [];
    rightYs = [];
    y = height / 2 - pitch * right.length / 2 + pitch / 2;
    noRightText = true;
    for (k = 0, len1 = right.length; k < len1; k++) {
      i = right[k];
      if (i === '--') {
        if (typeof rightFirst === "undefined" || rightFirst === null) {
          rightFirst = rightPins.length - 1;
        }
        rightLast = rightPins.length;
        rightYs.push(y);
        y += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'left';
      rightPins.push(pin);
      if (pin.name.length) {
        noRightText = false;
      }
      w = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      x2 = textWidth / 2 + w + space;
      if (x < x2) {
        x = x2; // Make symbol wider
      }
      y += pitch;
    }
    width = Math.max(width, 2 * x);
    width = 2 * symbol.alignToGrid(width / 2, 'ceil');
    // Box
    symbol.lineWidth(settings.lineWidth.thick).rectangle(-width / 2, 0, width / 2, height, settings.fill);
    if (schematic.showPinNames) {
      symbol.line(-textWidth / 2 - space, 0, -textWidth / 2 - space, height);
    }
    if (schematic.showPinNames) {
      symbol.line(textWidth / 2 + space, 0, textWidth / 2 + space, height);
    }
    // Gap lines
    x1 = width / 2;
    x2 = textWidth / 2 + space;
    for (l = 0, len2 = leftYs.length; l < len2; l++) {
      y = leftYs[l];
      symbol.line(-x1, y, -x2, y);
    }
    for (m = 0, len3 = rightYs.length; m < len3; m++) {
      y = rightYs[m];
      symbol.line(x1, y, x2, y);
    }
    // Left pins
    // Align first group to top
    if (leftFirst != null) {
      y = pitch;
      for (i = n = 0, ref3 = leftFirst; n <= ref3; i = n += 1) {
        leftPins[i].y = y;
        y += pitch;
      }
    }
    // Align last group to bottom
    if (leftLast != null) {
      y = height - (leftPins.length - leftLast) * pitch;
      i = leftLast;
      while (i < leftPins.length) {
        leftPins[i].y = y;
        y += pitch;
        ++i;
      }
    }
    for (o = 0, len4 = leftPins.length; o < len4; o++) {
      pin = leftPins[o];
      pin.x = -width / 2 - pinLength;
      symbol.pin(pin);
    }
    // Right pins
    // Align first group to top
    if (rightFirst != null) {
      y = pitch;
      for (i = p = 0, ref4 = rightFirst; p <= ref4; i = p += 1) {
        rightPins[i].y = y;
        y += pitch;
      }
    }
    // Align last group to bottom
    if (rightLast != null) {
      y = height - (rightPins.length - rightLast) * pitch;
      i = rightLast;
      while (i < rightPins.length) {
        rightPins[i].y = y;
        y += pitch;
        ++i;
      }
    }
    results = [];
    for (q = 0, len5 = rightPins.length; q < len5; q++) {
      pin = rightPins[q];
      pin.x = width / 2 + pinLength;
      results.push(symbol.pin(pin));
    }
    return results;
  };

}).call(this);
